
- name: Print the current user
  debug:
    msg: "The current user is {{ ansible_user}}"

- name: Initialize Kubernetes Master Node
  command: kubeadm init --pod-network-cidr=192.168.0.0/16

- name: Create .kube directory for current user
  file:
    path: /home/{{ ansible_user }}/.kube
    state: directory
    mode: '0755'

- name: Copy admin.conf to user's kube config
  copy:
    src: /etc/kubernetes/admin.conf
    dest: /home/{{ ansible_user }}/.kube/config
    remote_src: yes
    owner: "{{ ansible_user }}"
    group: "{{ ansible_user }}"
  become: yes

- name: Change ownership of kube config file
  file:
    path: /home/{{ ansible_user }}/.kube/config
    owner: "{{ ansible_user }}"
    group: "{{ ansible_user }}"
    state: file
  become: yes

- name: Export KUBECONFIG environment variable in .bashrc
  lineinfile:
    path: /home/{{ ansible_user }}/.bashrc
    line: 'export KUBECONFIG=/home/{{ ansible_user }}/.kube/config'
    create: yes
    state: present
  become: yes

- name: Pause for 30 seconds
  ansible.builtin.pause:
    seconds: 30

- name: crete for  Calico CNI network
  ansible.builtin.shell: kubectl create -f https://raw.githubusercontent.com/projectcalico/calico/v3.28.0/manifests/tigera-operator.yaml
  become: no


- name: crete Calico CNI network
  ansible.builtin.shell: kubectl create -f https://raw.githubusercontent.com/projectcalico/calico/v3.28.0/manifests/custom-resources.yaml
  become: no


- name: Get the token for joining the worker nodes
  shell: kubeadm token create --print-join-command
  register: kubernetes_join_command

- debug:
    msg: "{{ kubernetes_join_command.stdout }}"

- name: Copy join command to local file
  local_action:
    module: copy
    content: "{{ kubernetes_join_command.stdout }}"
    dest: "/tmp/kubernetes_join_command"
    mode: '0777'


